// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from novatel_gps_msgs:msg/NovatelReceiverStatus.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__STRUCT_H_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Struct defined in msg/NovatelReceiverStatus in the package novatel_gps_msgs.
/**
  * From the original Novatel receiver status message bitfield
  *  0     0x00000001   Error flag (Bit = 0: No Error, Bit = 1: Error)
  *  1     0x00000002   Temperature Status (0: Within Spec, 1: Warning)
  *  2     0x00000004   Voltage Supply Status (0: OK, 1: Warning)
  *  3     0x00000008   Antenna Power Status (0: Powered, 1: Not Powered)
  *  4     0x00000010   <Reserved>
  *  5     0x00000020   Antenna open flag (0: OK, 1: Open)
  *  6     0x00000040   Antenna shorted flag (0: OK, 1: Shorted)
  *  7     0x00000080   CPU overload flag
  *  8     0x00000100   COM1 buffer overrun flag (0: No overrun, 1: Overrun)
  *  9     0x00000200   COM2 buffer overrun flag (0: No overrun, 1: Overrun)
  *  10    0x00000400   COM3 buffer overrun flag (0: No overrun, 1: Overrun)
  *  11    0x00000800   USB buffer overrun flag (0: No overrun, 1: Overrun)
  *  12    0x00001000   <Reserved>
  *  13    0x00002000   <Reserved>
  *  14    0x00004000   <Reserved>
  *  15    0x00008000   RF1 AGC Status (0: OK, 1: Bad)
  *  16    0x00010000   <Reserverd>
  *  17    0x00020000   RF2 AGC status (0: OK, 1: Bad)
  *  18    0x00040000   Almanac flag/UTC known (0: Valid, 1: Invalid)
  *  19    0x00080000   Position solution flag (0: Valid, 1: Invalid)
  *  20    0x00100000   Position fixed flag (0: Not fixed, 1: Fixed)
  *  21    0x00200000   Clock steering status (0: Enabled, 1: Disabled)
  *  22    0x00400000   Clock model flag (0: Valid, 1: Invalid)
  *  23    0x00800000   OEMV external oscillator flag (0: Disabled, 1: Enabled)
  *  24    0x01000000   Software resource (0: OK, 1: Warning)
  *  25    0x02000000   <Reserved>
  *  26    0x04000000   <Reserved>
  *  27    0x08000000   <Reserved>
  *  28    0x10000000   <Reserved>
  *  29    0x20000000   Auxiliary 3 status event flag (0: No event, 1: Event)
  *  30    0x40000000   Auxiliary 2 status event flag (0: No event, 1: Event)
  *  31    0x80000000   Auxiliary 1 status event flag (0: No event, 1: Event)
 */
typedef struct novatel_gps_msgs__msg__NovatelReceiverStatus
{
  uint32_t original_status_code;
  bool error_flag;
  bool temperature_flag;
  bool voltage_supply_flag;
  bool antenna_powered;
  bool antenna_is_open;
  bool antenna_is_shorted;
  bool cpu_overload_flag;
  bool com1_buffer_overrun;
  bool com2_buffer_overrun;
  bool com3_buffer_overrun;
  bool usb_buffer_overrun;
  bool rf1_agc_flag;
  bool rf2_agc_flag;
  bool almanac_flag;
  bool position_solution_flag;
  bool position_fixed_flag;
  bool clock_steering_status_enabled;
  bool clock_model_flag;
  bool oemv_external_oscillator_flag;
  bool software_resource_flag;
  bool aux1_status_event_flag;
  bool aux2_status_event_flag;
  bool aux3_status_event_flag;
} novatel_gps_msgs__msg__NovatelReceiverStatus;

// Struct for a sequence of novatel_gps_msgs__msg__NovatelReceiverStatus.
typedef struct novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence
{
  novatel_gps_msgs__msg__NovatelReceiverStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_RECEIVER_STATUS__STRUCT_H_
